#include "includes.h"

void move_lasers(void)
{
    for(int i = 0; i < MAX_LASERS; i++)
    {
        laser[i].update_position();

        /* see if laser is past the top of the screen */
        if(laser[i].collide_rect(fix(0), fix(-40), fix(320), fix(20)))
        {
            laser[i].deactivate();
        }

        /* see if laser is hitting spinners */
        for(int j = 0; j < MAX_SMALL_SPINNERS; j++)
        {
            if(laser[i].collide_perfect(&small_spinner[j]))
            {
                small_spinner[j].deactivate();
                laser[i].deactivate();
                generate_explosion(&small_spinner[j]);
                score += small_spinner_score[level];
                break;
            }
        }

        /* see if laser is hitting spinners */
        for(int j = 0; j < MAX_BIG_SPINNERS; j++)
        {
            if(laser[i].collide_perfect(&big_spinner[j]))
            {
                big_spinner[j].deactivate();
                laser[i].deactivate();
                generate_explosion(&big_spinner[j]);
                score += big_spinner_score[level];
                break;
            }
        }

        /* see if laser is hitting pulsars */
        for(int j = 0; j < MAX_PULSARS; j++)
        {
            if(laser[i].collide(&pulsar[j]))
            {
                pulsar[j].deactivate();
                laser[i].deactivate();
                generate_explosion(&pulsar[j]);
                score += pulsar_score[level];
                break;
            }
        }

        /* see if laser is hitting asteroids */
        for(int j = 0; j < MAX_BIG_ASTEROIDS; j++)
        {
            /* if laser collides with big_asteroid */
            if(laser[i].collide(&big_asteroid[j]))
            {
                big_asteroid[j].deactivate();
                laser[i].deactivate();
                if(chance(asteroid_split_prob[level], PROB_TOTAL) && can_split() && big_asteroid[j].get_oy() < 86)
                {
                    split_big_asteroid(j);
                }
                generate_explosion(&big_asteroid[j]);
                score += big_asteroid_score[level];
                break;
            }
        }

        /* see if laser is hitting asteroids */
        for(int j = 0; j < MAX_SMALL_ASTEROIDS; j++)
        {
            if(laser[i].collide(&small_asteroid[j]))
            {
                small_asteroid[j].deactivate();
                laser[i].deactivate();
                generate_explosion(&small_asteroid[j]);
                score += small_asteroid_score[level];
                break;
            }
        }

        /* see if laser is hitting ufos */
        for(int j = 0; j < MAX_UFOS; j++)
        {
            if(laser[i].collide(&ufo[j]))
            {
                ufo[j].deactivate();
                laser[i].deactivate();
                generate_explosion(&ufo[j]);
                score += ufo_score[level];
                break;
            }
        }

        for(int j = 0; j < MAX_UFO_BOMBS; j++)
        {
            if(laser[i].collide(&ufo_bomb[j]))
            {
                ufo_bomb[j].deactivate();
                laser[i].deactivate();
                generate_explosion(&ufo_bomb[j]);
                break;
            }
        }
    }
    for(int i = 0; i < MAX_UFO_BOMBS; i++)
    {
        ufo_bomb[i].update_position();
        if(ufo_bomb[i].collide_perfect(&turret))
        {
            astro_death();
            if(boss4.active())
            {
                boss_state = B4_LASERFIRE;
                misc_counter2 = 0;
            }
            break;
        }
    }
    for(int i = 0; i < MAX_UFO_BOMBS; i++)
    {
        magic_bomb[i].update_position();
        if(magic_bomb[i].collide_perfect(&turret))
        {
            astro_death();
            if(boss4.active())
            {
                boss_state = B4_LASERFIRE;
                misc_counter2 = 0;
            }
            break;
        }
    }
    for(int i = 0; i < 5; i++)
    {
        boss_laser[i].update_position();
        if(boss_laser[i].collide_perfect(&turret))
        {
            astro_death();
            if(boss4.active())
            {
                boss_state = B4_LASERFIRE;
                misc_counter2 = 0;
                break;
            }
        }
    }
}

void do_lasers(void)
{
    move_lasers();
}
