#include "includes.h"

BITMAP * pong_bg;
ANIMATION paddle_animation;
ANIMATION ball_animation;
char pong_over = 0;
BASIC_SPRITE paddle[2];
BASIC_SPRITE ball;
int p1_score;
int p2_score;
fix ball_acc(1.0);
fix angle_chart[18] = { fix(32), fix(24), fix(16), fix(8), fix(0), fix(248),
    fix(240), fix(232), fix(224), fix(96), fix(104), fix(112), fix(120),
    fix(128), fix(136), fix(144), fix(152), fix(160) };
char current_angle = 5;
int predicted_y;

int pick_reverse_angle_x(char index)
{
    if(index <= 8)
    {
        return index + 9;
    }
    else
    {
        return index - 9;
    }
}

int pick_reverse_angle_y(char index)
{
    if(index == 0)
    {
        return 8;
    }
    if(index == 1)
    {
        return 7;
    }
    if(index == 2)
    {
        return 6;
    }
    if(index == 3)
    {
        return 5;
    }
    if(index == 5)
    {
        return 3;
    }
    if(index == 6)
    {
        return 2;
    }
    if(index == 7)
    {
        return 1;
    }
    if(index == 8)
    {
        return 0;
    }
    if(index == 9)
    {
        return 17;
    }
    if(index == 10)
    {
        return 16;
    }
    if(index == 11)
    {
        return 15;
    }
    if(index == 12)
    {
        return 14;
    }
    if(index == 14)
    {
        return 12;
    }
    if(index == 15)
    {
        return 11;
    }
    if(index == 16)
    {
        return 10;
    }
    if(index == 17)
    {
        return 9;
    }
}

void pong_ai_predict(void)
{
    fix oldx, oldy;
    char old_angle;

    if(!paddle[0].collide(&ball) && !paddle[1].collide(&ball))
    {
        oldx = ball.get_x();
        oldy = ball.get_y();
        old_angle = current_angle;
        while(ball.get_x() < 300 && ball.get_xspeed() > 0 && !key[KEY_ESC])
        {
            pong_move_ball(1);
        }
        predicted_y = ball.get_y() + ncd_random() % 59 - 29;
        ball.set_position(oldx, oldy);
        current_angle = old_angle;
        ball.set_speed(ball_acc * cos(angle_chart[current_angle]), ball_acc * sin(angle_chart[current_angle]));
    }
}

void pong_init(void)
{
    pong_bg = load_pcx(DATADIR "astro.dat#pong_backdrop", NULL);
    load_animation(&paddle_animation, DATADIR "astro.dat#pong_paddle");
    load_animation(&ball_animation, DATADIR "astro.dat#pong_ball");

    /* initialize paddle 0 */
    paddle[0].initialize(&paddle_animation);
    paddle[0].set_friction(fix(0), fix(0.5));
    paddle[0].set_acceleration(fix(0), fix(1));
    paddle[0].set_max_speed(fix(0), fix(1.5));
    paddle[0].set_boundary(fix(2), fix(18), fix(308), fix(166), BOUNDARY_STOP);
    paddle[0].set_position(fix(2), fix(76 + 16));
    paddle[0].activate();

    /* initialize paddle 1 */
    paddle[1].initialize(&paddle_animation);
    paddle[1].set_friction(fix(0), fix(0.5));
    paddle[1].set_acceleration(fix(0), fix(1));
    paddle[1].set_max_speed(fix(0), fix(1.5));
    paddle[1].set_boundary(fix(2), fix(18), fix(308), fix(166), BOUNDARY_STOP);
    paddle[1].set_position(fix(308), fix(76 + 16));
    paddle[1].activate();

    /* ball */
    ball_acc = 1;
    current_angle = ncd_random() % 18;
    ball.initialize(&ball_animation);
    ball.set_position(fix(155), fix(82));
    ball.set_speed(ball_acc * cos(angle_chart[current_angle]), ball_acc * sin(angle_chart[current_angle]));
    ball.activate();

    pong_over = 0;
    p1_score = 0;
    p2_score = 0;
    pong_ai_predict();
}

void pong_exit(void)
{
    destroy_bitmap(pong_bg);
    destroy_animation(&paddle_animation);
    destroy_animation(&ball_animation);
}

void pong_move_ball(int mode)
{
    ball.update_position();
    if(mode == 0)
    {
        if(paddle[0].collide(&ball))
        {
            ball.set_position(paddle[0].get_x() + 8, ball.get_y());
            current_angle = pick_reverse_angle_x(current_angle);
            if(paddle[0].get_yspeed() < 0)
            {
                if(current_angle != 17 && current_angle != 8)
                {
                    current_angle++;
                }
            }
            if(paddle[0].get_yspeed() > 0)
            {
                if(current_angle != 9 && current_angle != 0)
                {
                    current_angle--;
                }
            }
            ball.set_speed(ball_acc * cos(angle_chart[current_angle]), ball_acc * sin(angle_chart[current_angle]));
            pong_ai_predict();
            t3ss_play_sound(secret_sound_1, t3ss_place_sound(ball.get_ox(), 318), -1);
        }
        if(paddle[1].collide(&ball))
        {
            ball.set_position(paddle[1].get_x() - 8, ball.get_y());
            current_angle = pick_reverse_angle_x(current_angle);
            if(paddle[1].get_yspeed() < 0)
            {
                if(current_angle != 8 && current_angle != 17)
                {
                    current_angle++;
                }
            }
            if(paddle[1].get_yspeed() > 0)
            {
                if(current_angle != 0 && current_angle != 9)
                {
                    current_angle--;
                }
            }
            ball.set_speed(ball_acc * cos(angle_chart[current_angle]), ball_acc * sin(angle_chart[current_angle]));
            t3ss_play_sound(secret_sound_1, t3ss_place_sound(ball.get_ox(), 318), -1);
        }
    }
    if(ball.get_x() <= 2)
    {
        ball.set_position(fix(2), ball.get_y());
        current_angle = pick_reverse_angle_x(current_angle);
        if(mode == 0)
        {
            ball_acc = 1;
            ball.set_speed(ball_acc * cos(angle_chart[current_angle]), ball_acc * sin(angle_chart[current_angle]));
            p2_score++;
            t3ss_play_sound(secret_sound_2, t3ss_place_sound(ball.get_ox(), 318), -1);
            pong_ai_predict();
        }
    }
    if(ball.get_x() >= 308)
    {
        ball.set_position(fix(308), ball.get_y());
        current_angle = pick_reverse_angle_x(current_angle);
        if(mode == 0)
        {
            ball_acc = 1;
            ball.set_speed(ball_acc * cos(angle_chart[current_angle]), ball_acc * sin(angle_chart[current_angle]));
            p1_score++;
            t3ss_play_sound(secret_sound_2, t3ss_place_sound(ball.get_ox(), 318), -1);
        }
    }
    if(ball.get_y() <= 18)
    {
        ball.set_position(ball.get_x(), fix(18));
        current_angle = pick_reverse_angle_y(current_angle);
        ball.set_speed(ball_acc * cos(angle_chart[current_angle]), ball_acc * sin(angle_chart[current_angle]));
        if(mode == 0)
        {
            t3ss_play_sound(secret_sound_2, t3ss_place_sound(ball.get_ox(), 318), -1);
        }
    }
    if(ball.get_y() >= 190)
    {
        ball.set_position(ball.get_x(), fix(190));
        current_angle = pick_reverse_angle_y(current_angle);
        ball.set_speed(ball_acc * cos(angle_chart[current_angle]), ball_acc * sin(angle_chart[current_angle]));
        if(mode == 0)
        {
            t3ss_play_sound(secret_sound_2, t3ss_place_sound(ball.get_ox(), 318), -1);
        }
    }
}

void pong_control(void)
{
    ncd_joy_poll();
    if(key[KEY_UP] || ncd_joy_up(0))
    {
        paddle[0].accelerate(0, -1);
    }
    if(key[KEY_DOWN] || ncd_joy_down(0))
    {
        paddle[0].accelerate(0, 1);
    }
    if(key[KEY_ESC])
    {
        pong_over = 1;
    }
    if(ball.get_xspeed() > 0 && ball.get_x() < 290 && ball.get_ox() >= 80)
    {
        if(paddle[1].get_oy() < predicted_y)
        {
            paddle[1].accelerate(0, 1);
        }
        if(paddle[1].get_oy() > predicted_y + 8)
        {
            paddle[1].accelerate(0, -1);
        }
    }
    else if(ball.get_xspeed() > 0 && ball.get_x() >= 290)
    {
        if(paddle[1].get_oy() < ball.get_y())
        {
            paddle[1].accelerate(0, 1);
        }
        if(paddle[1].get_oy() > ball.get_y() + 8)
        {
            paddle[1].accelerate(0, -1);
        }
    }
}

void pong_update(void)
{
    if(ball_acc < 5)
    {
        ball_acc += 0.0005;
    }
    paddle[0].update_position();
    paddle[1].update_position();
    pong_move_ball(0);

    blit(pong_bg, astro_screen, 0, 0, 0, 0, 318, 200);
    paddle[0].draw(astro_screen);
    paddle[1].draw(astro_screen);
    ball.draw(astro_screen);
    ncd_draw_number(astro_screen, &astro_font, 0, 0, p1_score, 2);
    ncd_draw_number(astro_screen, &astro_font, 286, 0, p2_score, 2);
    vsync();
    stretch_blit(astro_screen, screen, 0, 0, 320, 200, 1*2, 0*2, 320*2, 480);
}

void pong_check_winner(void)
{
    if(p1_score >= 10)
    {
        blit(pong_bg, astro_screen, 0, 0, 0, 0, 318, 200);
        paddle[0].draw(astro_screen);
        paddle[1].draw(astro_screen);
        ball.draw(astro_screen);
        ncd_draw_number(astro_screen, &astro_font, 0, 0, p1_score, 2);
        ncd_draw_number(astro_screen, &astro_font, 286, 0, p2_score, 2);
        ncd_printf(astro_screen, &astro_font, 46, 100, "Player 1 Wins!");
        vsync();
        stretch_blit(astro_screen, screen, 0, 0, 320, 200, 1*2, 0*2, 320*2, 480);
        clear_keybuf();
        while(!keypressed());
        pong_over = 1;
    }
    else if(p2_score >= 10)
    {
        blit(pong_bg, astro_screen, 0, 0, 0, 0, 318, 200);
        paddle[0].draw(astro_screen);
        paddle[1].draw(astro_screen);
        ball.draw(astro_screen);
        ncd_draw_number(astro_screen, &astro_font, 0, 0, p1_score, 2);
        ncd_draw_number(astro_screen, &astro_font, 286, 0, p2_score, 2);
        ncd_printf(astro_screen, &astro_font, 47, 100, "Player 2 Wins!");
        vsync();
        stretch_blit(astro_screen, screen, 0, 0, 320, 200, 1*2, 0*2, 320*2, 480);
        clear_keybuf();
        while(!keypressed());
        pong_over = 1;
    }
}

void play_pong(void)
{
    pong_init();
    t3ss_play_mod(NULL);
    pong_update();
    fade_in(astro_palette, 3);
    while(!pong_over)
    {
        pong_control();
        pong_update();
        pong_check_winner();
    }
    fade_out(3);
    t3ss_stop_mod();
    pong_exit();
}
